

function setup()
    viewer.mode = FULLSCREEN
    viewer.preferredFPS = 120
    dynamicObjs = {}
    sceneObjects = {}
    models:init()
    worldPhysics:init()
    holdingItem = false
    heldItem = nil
    holdingItem = false
    itemsUsed = {}
    itemsUsedType = nil
    usingItem = false
    vehicleDriving = nil
    useItem = false
    driving = false
    steeringAngle = 0
    gas = 0
    brake = 0
    
    crouching = false
    touches = {}
    
    joystick:init( WIDTH/4, HEIGHT/3, 125)
    pickUpButton = button( WIDTH/6 * 5, HEIGHT/2, 65, ENDED, 
    function()  
        if grabRay then
            if not holdingItem then
                for i, n in pairs(itemsUsed) do
                    if grabRay.entity == n.entity then
                        return
                    end
                end
                holdingItem = true
                grabSpring = spring(grabRay.entity.position)
            else
                holdingItem = false
            end
        else
            if holdingItem then
                holdingItem = false
            end
        end
    end)
    jumpButton = button( WIDTH/6 * 5, HEIGHT/2 - 80, 65, ENDED, 
    function() 
        playerBody:applyForce(vec3(0, 500, 0))
    end)
    useButton = button( WIDTH/6 * 5 - 50, HEIGHT/2 + 60, 65, ENDED, 
    function()  
        if grabRay then
            for i, n in pairs(itemsUsed) do
                if n.entity:get(craft.rigidbody).group == grabRay.entity:get(craft.rigidbody).group then
                    table.remove(itemsUsed, i)
                    return
                end
            end
            table.insert(itemsUsed, grabRay)
        end
    end)
    crouchButton = button( WIDTH/6 * 5 - 50, HEIGHT /8, 65, ENDED, 
    function()  
        if crouching then
            playerBody:applyForce(vec3(0, 250, 0))
            crouching = false
        else
            crouching = true
        end
    end)
    
    steeringWheel = swipeWheel(WIDTH/2 - WIDTH/4, HEIGHT/2 - 100, 100, color(58, 46, 29), 2)
    
    gasPedal = pedal(WIDTH/2 + 100, HEIGHT/4 - 150, 50, 100, color(60, 157), 1)
    
    brakePedal = pedal(WIDTH/2 + 25, HEIGHT/4 - 150, 70, 60, color(60, 157), 1)
end

function draw()
    worldPhysics:draw()
    
    player:draw()
    
    scene:update(DeltaTime)
    
    driving = false
    
    --attach here v
    
    for n,i in pairs(dynamicObjs) do
        i()
    end
    
    for n, i in pairs(itemsUsed) do
        if i.entity:get(craft.rigidbody).group == 2 then
            player.player.position = i.entity.position + (i.entity.up * 1.5)
            player.player.rotation = player.player.rotation * i.entity.rotation
            crouching = true
        end
        if i.entity:get(craft.rigidbody).group == 3 then
            if player.player.position:dist(i.entity.position) < 5 then
                driving = true
            else
                table.remove(itemsUsed, n)
                driving = false
            end
        end
    end
    
    -- attach here ^
    
    scene:draw()
    
    if driving then
        steeringAngle = steeringWheel:draw()
        gas = math.ceil((gasPedal:draw() / 80) * 100)/100
        brake = math.ceil((brakePedal:draw() / 40) * 100)/100
    else
        joystick:draw()
        jumpButton:draw("jump")
        crouchButton:draw("crouch")
    end
    pickUpButton:draw("grab")
    
    text(#itemsUsed, WIDTH - 80, HEIGHT - 120)
    
    for n, i in pairs(itemsUsed) do
        if i.entity:get(craft.rigidbody).group == 2 then
            sprite(asset.sitIcon, WIDTH - 80, HEIGHT - HEIGHT / 10)
        end
        if i.entity:get(craft.rigidbody).group == 3 then
            sprite(asset.driveIcon, WIDTH - 120, HEIGHT - HEIGHT / 10)
        end
    end
    
    grabRay = scene.physics:raycast(player.player.position, scene.camera.forward, 5)
    
    if grabRay then
        text("•", WIDTH/2, HEIGHT/2)
        if grabRay.entity:get(itemNames) then
            pushStyle()
            fontSize(10)
            text(grabRay.entity:get(itemNames).name, WIDTH/2, HEIGHT/2 - 10)
            popStyle()
        end
        
        if holdingItem then
            if not alreadyHolding then
                if grabRay.entity:get(craft.rigidbody).group ~= 5 then
                    heldItem = grabRay.entity
                    alreadyHolding = true
                end
            end
        else
            
        end
        if grabRay.entity:get(craft.rigidbody).group == 2 then
            useButton:draw("sit")
            useItem = true
        elseif grabRay.entity:get(craft.rigidbody).group == 3 then
            useButton:draw("drive")
            useItem = true
        else
            useItem = false
        end
    end
    
    if alreadyHolding then
        if holdingItem then
            pushStyle()
            font("Copperplate-Bold")
            text("( )", WIDTH/2, HEIGHT/2 + 1)
            popStyle()
            
            local target = player.player.position + (scene.camera.forward * 2)
            
            grabSpring:draw(heldItem, target, 50, 10)
            
        else
            alreadyHolding = false
        end
    end
    
    if crouching then
        player.player.scale = vec3(0.45,0.45,0.45)
    else
        player.player.scale = vec3(1,1,1)
    end
    
    if holdingItem then
        for i,n in pairs(itemsUsed) do
            if heldItem == n.entity then
                table.remove(itemsUsed, i)
            end
        end
    end
    
    --[[
    for i, objects in pairs(sceneObjects) do
        local b = objects:get(craft.renderer).model.bounds
        b2 = bounds(b.min, b.max)
        b2:translate(objects.position)
        scene.debug:bounds(b2, color(255))
    end
    ]]
    
    text("Frame Rate  "..1//DeltaTime,WIDTH/2,HEIGHT-70)
    text("KB Memory used  "..collectgarbage("count")//1,WIDTH/2,HEIGHT-100)
    
    text((math.floor(player.player.position.x/10)*10) .. "," ..(math.floor(player.player.position.y/10)*10) .. "," .. (math.floor(player.player.position.z/10)*10), WIDTH / 2, HEIGHT - 200)
    
    --[[
    draw3DLine(FRpos, vec3(0,-1,0), FRleng, color(255, 14, 0), FRoffs, FRforc, FRvelo, FLvel)
    draw3DLine(FLpos, vec3(0,-1,0), FLleng, color(255, 14, 0), FLoffs, FLforc, FLvelo, FRvel)
    draw3DLine(RRpos, vec3(0,-1,0), RRleng, color(255, 14, 0), RRoffs, RRforc, RLvelo, RLvel)
    draw3DLine(RLpos, vec3(0,-1,0), RLleng, color(255, 14, 0), RLoffs, RLforc, RLvelo, RRvel)
    ]]
end

function touched(touch)
    
    touches[touch.id] = touch
    for i,t in pairs(touches) do
        player:touched(t)
        if driving then
            steeringWheel:touched(t)
            gasPedal:touched(t)
            brakePedal:touched(t)
        else
            jumpButton:touched(t)
            crouchButton:touched(t)
            joystick:touched(t)
        end
        pickUpButton:touched(t)
        
        if useItem then
            useButton:touched(t)
        end
    end
    
end
