
function spawnBox(pos)
    -- create assets
    local box = scene:entity()
    box.model = craft.model.cube(vec3(0.5,0.5,0.5))
    box.material = craft.material(asset.documents.Brick_wall)
    box:add(craft.rigidbody, DYNAMIC, 0.25)
    box:add(craft.shape.box, vec3(0.5,0.5,0.5))
    box.position = pos
    box:get(craft.rigidbody).sleepingAllowed = false
    box:add(itemNames, "box")
    sceneObjects[#sceneObjects+1] = box
    return box
end


function spawnSpeedBump(pos)
    -- create assets
    local box = scene:entity()
    box.model = craft.model.cube(vec3(5,0.5,0.5))
    box.material = craft.material(asset.builtin.Materials.Standard)
    box:add(craft.rigidbody, STATIC)
    box:add(craft.shape.box, vec3(5,0.5,0.5))
    box.eulerAngles = vec3(0,0,0)
    box.position = pos
end
function vehicle1(pos)
    --- car body 
    local car = scene:entity()
    car.group = 2
    car.position = pos
    car.model = craft.model.cube( vec3( 2.4, 0.1, 3), vec3(0 , 0, 0))
    car.material = craft.material(asset.builtin.Materials.Standard)
    car.interpolate = false
    car.material.diffuse = color(197)
    car.eulerAngles = vec3(0,0,0)
    car:add(craft.rigidbody, DYNAMIC, 50)
    car:add(craft.shape.box, vec3( 2.4, 0.1, 3), vec3(0 , 0, 0))
    local carSpeed = 0
    
    car:add(itemNames, "")
    
    --- car dashboard
    local dash = scene:entity()
    dash.model = craft.model.cube(vec3(2,0.07,0.5))
    local dashMat = craft.material(asset.documents.Standard)
    dashMat.diffuse = color(37)
    dashMat.roughness = 0
    --dashMat.metalic = 1
    --dashMat.envMap = craft.cubeTexture(asset.documents.HDR_029_Sky_Cloudy_Bg)
    
    dash.material = dashMat
    dash:add(craft.rigidbody, STATIC, 0)
    dash:add(craft.shape.box, vec3(2,0.07,0.5))
    dash:add(itemNames, "")
    
    local dashRear = scene:entity()
    dashRear.model = craft.model.cube(vec3(2,1.25,0.07))
    dashRear.material = dashMat
    dashRear:add(craft.rigidbody, STATIC, 0)
    dashRear:add(craft.shape.box, vec3(2,1.15,0.07))
    dashRear:add(itemNames, "")
    
    -- gauges
    speedometerN, speedometerG = gauge(0.5, 0.25, -0.25, vec3(0,0,0), 0.1, dash, color(236))
    
    
    --- steering Wheel
    local steeringWhl = scene:entity()
    steeringWhl.model = craft.model(asset.builtin.Primitives.Capsule)
    steeringWhl.material = craft.material(asset.builtin.Materials.Standard)
    steeringWhl.scale = vec3(0.5, 0.05, 0.5)
    steeringWhl:add(craft.rigidbody, STATIC).group = 3
    steeringWhl:add(craft.shape.model, steeringWhl.model)
    steeringWhl:add(itemNames, "steering wheel")
    
    table.insert(dynamicObjs, function()
        dash.position = car.position + (car.forward * 1.25) + (car.up * 1.25)
        dash.rotation = car.rotation
        dashRear.position = car.position + (car.forward * 1.5) + (car.up * 0.65)
        dashRear.rotation = car.rotation
        
        steeringWhl.position = dash.position + (dash.right * 0.5) + (-dash.forward * 0.5) + (dash.up * 0)
        
        steeringWhl.rotation = dash.rotation * quat.eulerAngles(-70,0,0)
        
        moveNeedle(speedometerN, speedometerG, carSpeed)
    end)
    
    ---body
    local carHood = scene:entity()
    carHood.model = craft.model.cube( vec3 ( 2.5, 1, 1.25))
    carPaint = craft.material(asset.builtin.Materials.Specular)
    carPaint.envMap = craft.cubeTexture(asset.documents.HDR_029_Sky_Cloudy_Bg)
    carHood.material = carPaint
    carHood:add(craft.rigidbody, STATIC).mask = 2
    carHood:add(craft.shape.box, vec3(2.5, 1, 1.25))
    table.insert(dynamicObjs, function()
        carHood.position = car.position + (car.up * 0.5) + (car.forward * 2.25)
        carHood.rotation = car.rotation
    end)
    local carTrunk = scene:entity()
    carTrunk.model = craft.model.cube( vec3 ( 2.5, 1, 1.25))
    carTrunk.material = carPaint
    carTrunk:add(craft.rigidbody, STATIC)
    carTrunk:add(craft.shape.box, vec3(2.5, 1, 1.25))
    table.insert(dynamicObjs, function()
        carTrunk.position = car.position + (car.up * 0.5) + (-car.forward * 2.15)
        carTrunk.rotation = car.rotation
    end)
    local leftFender = scene:entity()
    leftFender.model = craft.model.cube( vec3 ( 0.15, 0.9, 0.75))
    leftFender.material = carPaint
    leftFender:add(craft.rigidbody, STATIC)
    leftFender:add(craft.shape.box, vec3(0.15, 0.9, 0.75))
    table.insert(dynamicObjs, function()
        leftFender.position = car.position + (car.up * 0.55) + (-car.forward * 1.15) + (car.right * 1.175)
        leftFender.rotation = car.rotation
    end)
    local rightFender = scene:entity()
    rightFender.model = craft.model.cube( vec3 ( 0.15, 0.9, 0.75))
    rightFender.material = carPaint
    rightFender:add(craft.rigidbody, STATIC)
    rightFender:add(craft.shape.box, vec3(0.15, 0.9, 0.75))
    table.insert(dynamicObjs, function()
        rightFender.position = car.position + (car.up * 0.55) + (-car.forward * 1.15) + (-car.right * 1.175)
        rightFender.rotation = car.rotation
    end)
    
    
    
    ---physics
    local carPhysics = car:get(craft.rigidbody)
    carPhysics.sleepingAllowed = false
    carPhysics.friction = 1
    
    
    ---sockets
    local driverSeatSocket = socket(car)
    local passSeatSocket = socket(car)
    
    --- wheel physics
    local springFL = suspension(car)
    local springFR = suspension(car)
    local springRL = suspension(car)
    local springRR = suspension(car)
    local tireFL = wheel1(nil, vec3(0,0,0))
    local tireFR = wheel1(nil, vec3(0,0,0))
    local tireRL = wheel1(nil, vec3(0,0,0))
    local tireRR = wheel1(nil, vec3(0,0,0))
    local tireForceFL = wheelForce(car)
    local tireForceFR = wheelForce(car)
    local tireForceRL = wheelForce(car)
    local tireForceRR = wheelForce(car)
    
    local whlAngle = 0
    local whlAcc = 0
    local whlBrk = 0
    --- car.update 
    table.insert(dynamicObjs, function()
        for n, i in pairs(itemsUsed) do
            if i.entity == steeringWhl then
                whlAngle = steeringAngle
                whlAcc = gas
                whlBrk = brake
            end
        end
        carSpeed = car:get(craft.rigidbody).linearVelocity:dist(vec3(0,0,0))
        FLpos, FLleng, FLoffs, FLforc, FLvelo = springFL:draw(car.forward * 2.25, -car.right * 1.5)
        FRpos, FRleng, FRoffs, FRforc, FRvelo = springFR:draw(car.forward * 2.25, car.right * 1.5)
        RLpos, RLleng, RLoffs, RLforc, RLvelo = springRL:draw(-car.forward * 2, -car.right * 1.5)
        RRpos, RRleng, RRoffs, RRforc, RRvelo = springRR:draw(-car.forward * 2, car.right * 1.5)
        
        --- update tires

        tireFL.position = FLpos + (-car.up * FLleng)
        tireFL.rotation = car.rotation * quat.eulerAngles(0 , whlAngle * 0.65, 0)


        tireFR.position = FRpos + (-car.up * FRleng)
        tireFR.rotation = car.rotation * quat.eulerAngles(0 , whlAngle * 0.65, 0)


        tireRL.position = RLpos + (-car.up * RLleng)
        tireRL.rotation = car.rotation


        tireRR.position = RRpos + (-car.up * RRleng)
        tireRR.rotation = car.rotation

        FLvel = tireForceFL:draw(car, tireFL,  car.forward * 3 + -car.right * 1.5, 0, 0, 0, 0.58)
        FRvel = tireForceFR:draw(car, tireFR,  car.forward * 3 + car.right * 1.5, 0, 0, 0, 0.58)
        RLvel = tireForceRL:draw(car, tireRL, -car.forward * 3 + -car.right * 1.5, whlAcc, whlBrk, 180, 0.74)
        RRvel = tireForceRR:draw(car, tireRR, -car.forward * 3 + car.right * 1.5, whlAcc, whlBrk, 180, 0.74)
        driverSeatSocket:draw(car, 2,(car.right * 0.5) + (car.forward * 0.1), car.position + (car.right * 0.5) + (car.forward * 0.1) + (car.up * 0.23), car.rotation)
        passSeatSocket:draw(car, 2, (-car.right * 0.5) + (car.forward * 0.1), car.position + (-car.right * 0.5) + (car.forward * 0.1) + (car.up * 0.23), car.rotation)
    end)
end

function gauge(x, y, z, rot, size, parent, col)
    local gauge = scene:entity()
    gauge.model = craft.model(asset.builtin.Primitives.Sphere)
    gauge.material = craft.material(asset.builtin.Materials.Standard)
    gauge.material.diffuse = col
    gauge.parent = parent
    gauge.position = (parent.right * x) + (parent.up * y) + (parent.forward * z)
    gauge.rotation = parent.rotation * quat.eulerAngles(rot.x, rot.y, rot.z)
    gauge.scale = vec3(0.5 * size, 0.5 * size, 0.05 * size)
    local needle = scene:entity()
    needle.model = craft.model.cube(vec3(5,0,0.65 ), vec3(-1,0,0))
    needle.material = craft.material(asset.builtin.Materials.Standard)
    needle.material.diffuse = color(189, 38, 30)
    needle.parent = parent
    needle.position = (parent.right * x) + (parent.up * y) + (parent.forward * z)
    needle.position = needle.position + (-needle.forward * (0.05 * size))
    needle.scale = vec3(0.1 * size, 0.2 * size, 0.05 * size)
    return needle, gauge
end

function moveNeedle(needle, gauge, speed)
    needle.rotation = gauge.rotation * quat.eulerAngles(120 - speed, 90, -90)
end

function vehicleSeat(parent, pos)
    local seat = scene:entity()
    seat.model = craft.model.cube(vec3(0.5,0.25,0.5), vec3(0,0.25,0))
    seat.parent = parent
    seat.position = pos
    seat.material = craft.material(asset.builtin.Materials.Standard)
    local seatBack = scene:entity()
    seatBack.model = craft.model.cube(vec3(0.5,0.75,0.1), vec3(0,0.675,-0.3))
    seatBack.parent = seat
    seatBack.material = craft.material(asset.builtin.Materials.Standard)
    seatBack.eulerAngles = vec3(-15,0,0)
    seatBack.position = vec3(0,0.1,0.1)
    local seatBackTop = scene:entity()
    seatBackTop.model = craft.model.cube(vec3(0.35,0.25,0.1), vec3(0,1.15,-0.45))
    seatBackTop.parent = seat
    seatBackTop.material = craft.material(asset.builtin.Materials.Standard)
    local seatLegR = scene:entity()
    seatLegR.model = craft.model.cube(vec3(0.05,0.25,0.5), vec3(0.15,0,0))
    seatLegR.parent = seat
    seatLegR.material = craft.material(asset.builtin.Materials.Standard)
    local seatLegL = scene:entity()
    seatLegL.model = craft.model.cube(vec3(0.05,0.25,0.5), vec3(-0.15,0,0))
    seatLegL.parent = seat
    seatLegL.material = craft.material(asset.builtin.Materials.Standard)
    
    --- colors
    seat.material.diffuse = color(91, 63, 52)
    seatBack.material.diffuse = color(91, 63, 52)
    seatLegL.material.diffuse = color(141)
    seatLegR.material.diffuse = color(141)
    seatBackTop.material.diffuse = color(91, 63, 52)
    seatBackTop.material.diffuse = color(91, 63, 52)
    seatBack.material.roughness = 1
    seatBackTop.material.roughness = 1
    seat.material.roughness = 1
    --- hitbox
    seat:add(craft.rigidbody, DYNAMIC, 2)
    seat:add(craft.shape.box, vec3(0.5,0.5,0.5), vec3(0,0.1,0))
    seat:add(itemNames, "seat")
    --- physics
    seat:get(craft.rigidbody).sleepingAllowed = false
    seat:get(craft.rigidbody).group = 2
    seat:get(craft.rigidbody).friction = 1
    sceneObjects[#sceneObjects+1] = sear
    return seat
end

function vehicleDash1()
    dash = scene:entity()
    dash.model = carDash
    dash.material = craft.material(asset.documents.UV_map)
    dash.parent = parent
    dash.position = vec3(0,0,1.5)
    dash:add(craft.rigidbody, STATIC)
    dash:add(craft.shape.model, vec3(5,1,0.5), vec3(0,0,0.5))
    return dash
end

function wheel1(parent, pos)
    local wh = scene:entity()
    wh.model = craft.model(asset.builtin.Primitives.Sphere)
    wh.parent = parent
    wh.position = pos
    wh.material = craft.material(asset.builtin.Materials.Standard)
    wh.material.diffuse = color(29)
    wh.material.roughness = 1
    wh:add(craft.rigidbody, STATIC, 1)
    wh:add(craft.shape.box, vec3(1,1,1))
    wh:add(itemNames, "wheel")
    
    wh:get(craft.rigidbody).group = 1
    wh:get(craft.rigidbody).mask = 2
    wh.scale = vec3(0.2,0.5,0.5)
    return wh
end
