worldPhysics = class()

function worldPhysics:init()
    scene = craft.scene()
    --sky
    scene.sky.material = craft.material(asset.builtin.Materials.Skybox)
    --scene.sky.model = craft.model(asset.builtin.Primitives.Sphere)
    
    scene.sky.material.sky = color(181, 219, 224)
    function sky(col)
        scene.sky.material.diffuse = col
    end
    parameter.color("sky", color(103, 169, 228), sky)
    
    scene.sky.material.horizon = color(193, 218, 226)    
    function horizon(col)
        scene.sky.material.horizon = col
    end
    parameter.color("horizon", color(255)    , horizon)
    
    scene.sky.material.ground = color(219, 184, 153)
    function ground(col)
        scene.sky.material.ground = col
    end
    parameter.color("ground", color(219, 184, 153), ground)
    
    scene.fogNear = 80
    scene.fogFar = 100

    scene.fogColor = color(193, 218, 226)      
    function fogColor(col)
        scene.fogColor = col
    end
    parameter.color("fogColor", color(255), fogColor)
    
    scene.ambientColor = color(229, 221, 209)
    function skyColor(col)
        scene.ambientColor = col
    end
    parameter.color("sunAmbient", color(229, 186, 101), skyColor)
    
    scene.sun.rotation = quat.eulerAngles(25, 125, 0)
    scene.fogEnabled = true
    scene.sky.active = true
    
    -- sun
    scene.sun:get(craft.light).intensity = 0.25
    function skyInt(int)
        scene.sun:get(craft.light).intensity = int
    end
    parameter.number("sunInt",0, 1, 0.8, skyInt)
    
    -- ground material
    local m = craft.material(asset.documents.Desert_Sand)
    m.diffuse = color(213, 185, 150)
    m.maxTileSize = vec2(0.1,0.1)
    m.minTileSize = vec2(100,100)
    m.detailDistance = 20

    
    -- Create ground
    function createGround(pos)
        ground = scene:entity()
        ground.model = craft.model.cube(vec3(200,1,200), vec3(0,0,0))
        ground:add(craft.rigidbody, STATIC)
        ground:add(craft.shape.box, vec3(200,-1,200))
        ground.material = m
        ground.position = pos
    end
    
    createGround(vec3(0,0,0))
    
    -- Create Player
    self.sceneCam = scene.camera:get(craft.camera)
    self.sceneCam.fieldOfView = 100
    self.sceneCam.hrd = false
    local bloom = craft.bloomEffect()
    --self.sceneCam:addPostEffect(bloom)
    
    player = scene:entity():add(playerController, self.sceneCam, 0, 3, 0, 1, 0.3)

    spawnBox(vec3(0.25,5,10))
    --spawnBox(vec3(-0.25,5,10))
    --spawnBox(vec3(0,6,10))
    --box = spawnBox(vec3(0,3,6))
    spawnSpeedBump(vec3(1,0.5,10))
    spawnSpeedBump(vec3(1,0.5,11))
    spawnSpeedBump(vec3(1,0.5,12))
    --vehicle1(vec3(-5,2,5))
    vehicle1(vec3(5,2,5))
    local rightSeat = vehicleSeat(nil, vec3(0.5,3,5))

    local leftSeat = vehicleSeat(nil, vec3(-3,0,0))
    
    idk = chunkSpawn()
    
    backgroundSky = scene:entity()
    --backgroundSky.model = craft.model(asset.builtin.Primitives.Sphere)
    backgroundSky.material = craft.material(asset.documents.sky)
    scene.sky.size = vec3(0.5, 0.5, 0.5)
    
    scene.sky.position = player.player.position + (player.player.up * 100)
    backgroundSky.position = player.player.position
    
    probeEnt = scene:entity()
    probe = probeEnt:add(EnvironmentProbe, 1080)

    mirrorCube = scene:entity(1)
    --mirrorCube.model = craft.model.cube(vec3(10,10,1))
    mirrorCube.material = craft.material(asset.documents.carPaint)
    mirrorCube.position = vec3(0,3,5)
    frameI = 0
    probeEnt.position = vec3(0,5,0)
    scene.environment = probe:render()

end

function worldPhysics:draw()
    scene.sky.position = player.player.position + (player.player.up * 100)
    backgroundSky.position = player.player.position
    frameI = frameI + 1
    --if frameI == 1 then
        --frameI = 0
    --end
end
